<?php

// ========================================================================== //
//                                                                            //
//                        Значения имен и отчеств, v1.0                       //
//                                                                            //
//                      Copyright (C) 2012 Preventiva LLC                     //
//                         http://web2.0-developer.ru/                        //
//                                                                            //
// ========================================================================== //

if (!defined('VALID_CMS')) {
    die('ACCESS DENIED');
}

function vnaps() {

    //Инициализируем объекты, которые нам понадобятся
    //для работы: ядро, шаблонизатор и пользователь
    $inCore = cmsCore::getInstance();
    $inPage = cmsPage::getInstance();
    $inUser = cmsUser::getInstance();

    global $_LANG;

    //загрузим и создадим объект модели
    $inCore->loadModel('vnaps');
    $model = new cms_model_vnaps();

    // Проверяем установлен ли компонент
    if (!$inCore->isComponentInstalled('vnaps')) {
        cmsCore::error404();
    }

    // Проверяем включен ли компонент
    $cfg = $inCore->loadComponentConfig('vnaps');
    if (!$cfg['component_enabled']) {
        cmsCore::error404();
    }

    $pagetitle = $_LANG['VNAPS'];
    $inPage->addPathway($pagetitle, '/vnaps');
    $inPage->setDescription($_LANG['DESCRIPTION']);
    $inPage->setKeywords($_LANG['KEYWORDS']);

    //$inPage->addHeadJS('components/spshka/js/framework.js');
    //$inPage->addHeadCSS('components/spshka/css/framework.css');
    //Получаем текущее действие из URL страницы
    $do = $inCore->request('do', 'str', 'index');

// ========================================================================== //
    if ($do == 'index') {

        $inPage->setTitle($pagetitle);
        $smarty = $inCore->initSmarty('components', 'com_vnaps_index.tpl');
        $smarty->assign('title', $pagetitle);
        $smarty->assign('maleNames', $model->getMaleNamesCategory());
        $smarty->assign('malePatronymics', $model->getMalePatronymicsCategory());
        $smarty->assign('femaleNames', $model->getFemaleNamesCategory());
        $smarty->assign('femalePatronymics', $model->getFemalePatronymicsCategory());
        $smarty->assign('user_id', $inUser->id);
        $smarty->display('com_vnaps_index.tpl');
    }
// ========================================================================== //
    if ($do == 'delete') {

        $item_id = $inCore->request('id', 'int', 0);

        if (!$item_array = $model->getItemTitle($item_id)) {
            cmsCore::error404();
        }

        if ($item_array['author'] != $inUser->id && !$inUser->is_admin) {
            cmsCore::error404();
        }

        // Записываем значение и получаем флаг успеха
        $is_delete = $model->deleteItem($item_id);

        if ($is_delete) {
            // Сохраняем текст успеха
            cmsCore::addSessionMessage('Значение удалено!', 'success');
        }

        if (!$is_delete) {
            // Сохраняем текст неудачи
            cmsCore::addSessionMessage('Произошла ошибка при удалении значения!', 'error');
        }

        // Делаем редирект
        $inCore->redirect('/vnaps');
        exit;
    }
// ========================================================================== //
    if ($do == 'edit') {

        $is_submit = $inCore->inRequest('submit');

        // Если форма не отправлена
        if (!$is_submit) {
            $bb_toolbar = $inPage->getBBCodeToolbar('vnaps_content', 0, 'vnaps', 'vnaps');
            $smilies = $inPage->getSmilesPanel('vnaps_content');
            $inCore->initAutoGrowText('#vnaps_content');

            $item_id = $inCore->request('id', 'int', 0);

            if (!$item_array = $model->getItemTitle($item_id)) {
                cmsCore::error404();
            }

            if ($item_array['author'] != $inUser->id && !$inUser->is_admin) {
                cmsCore::error404();
            }

            $inPage->setTitle($_LANG['EDIT']);
            $inPage->addPathway($_LANG['EDIT'], '/vnaps/edit' . $item_id . '.html');
            $smarty = $inCore->initSmarty('components', 'com_vnaps_edit.tpl');
            $smarty->assign('title', $_LANG['EDIT']);
            $smarty->assign('item', $item_array);
            $smarty->assign('category', $model->getCategoryName());

            $is_author = ($inUser->id && ($item_array['author'] == $inUser->id));
            $smarty->assign('is_author', $is_author);
            $smarty->assign('is_admin', $inUser->is_admin);

            $smarty->assign('bb_toolbar_content', $bb_toolbar);
            $smarty->assign('smilies_content', $smilies);
            $smarty->display('com_vnaps_edit.tpl');
        }

        // Если форма отправлена
        if ($is_submit) {

            $item_id = $inCore->request('id', 'int', 0);

            if (!$item_array = $model->getItemTitle($item_id)) {
                cmsCore::error404();
            }

            if ($item_array['author'] != $inUser->id && !$inUser->is_admin) {
                cmsCore::error404();
            }

            $category = $inCore->request('category_id', 'int');
            $male = $inCore->request('male_id', 'int');
            $name = $inCore->request('name_id', 'int');
            $title = $inCore->request('title', 'str');
            $content = $inCore->request('content', 'str');

            // Если отсутствует переменная $male то присвоим ей 0
            if (!$male) {
                $male = 0;
            }

            // Если отсутствует переменная $name то присвоим ей 0
            if (!$name) {
                $name = 0;
            }

            if ($male > 2 || $name > 2) {
                $inCore->halt();
            }

            // Если нет названия рубрики
            if (!$title || !$content || $male == 2 || $name == 2 || $category == 0) {

                // Сохраняем текст ошибки в сессию
                cmsCore::addSessionMessage('Нужно заполнить все поля!', 'error');

                // Делаем редирект обратно на форму
                $inCore->redirectBack();
                exit;
            }

            // Записываем значение и получаем флаг успеха
            $is_edit = $model->editItem($item_id, $category, $title, $content, $male, $name);

            if ($is_edit) {
                // Сохраняем текст успеха
                cmsCore::addSessionMessage('Значение успешно сохранено!', 'success');
            }

            if (!$is_edit) {
                // Сохраняем текст неудачи
                cmsCore::addSessionMessage('Произошла ошибка при сохранении значения!', 'error');
            }

            // Делаем редирект на созданную запись
            $inCore->redirect('/vnaps/' . $male . $name . $category . '/' . $item_id);
            exit;
        }
    }
// ========================================================================== //
    if ($do == 'add') {

        $is_submit = $inCore->inRequest('submit');

        if (!$inUser->id) {
            cmsCore::error404();
        }

        // Если форма не отправлена
        if (!$is_submit) {
            $bb_toolbar = $inPage->getBBCodeToolbar('vnaps_content', 0, 'vnaps', 'vnaps');
            $smilies = $inPage->getSmilesPanel('vnaps_content');
            $inCore->initAutoGrowText('#vnaps_content');

            $inPage->setTitle($_LANG['ADD']);
            $inPage->addPathway($_LANG['ADD'], '/vnaps/add.html');
            $smarty = $inCore->initSmarty('components', 'com_vnaps_add.tpl');
            $smarty->assign('title', $_LANG['ADD']);
            $smarty->assign('category', $model->getCategoryName());
            $smarty->assign('bb_toolbar_content', $bb_toolbar);
            $smarty->assign('smilies_content', $smilies);
            $smarty->display('com_vnaps_add.tpl');
        }

        // Если форма отправлена
        if ($is_submit) {

            $category = $inCore->request('category_id', 'int');
            $male = $inCore->request('male_id', 'int');
            $name = $inCore->request('name_id', 'int');
            $title = $inCore->request('title', 'str');
            $content = $inCore->request('content', 'str');

            // Если отсутствует переменная $male то присвоим ей 0
            if (!$male) {
                $male = 0;
            }

            // Если отсутствует переменная $name то присвоим ей 0
            if (!$name) {
                $name = 0;
            }

            if ($male > 2 || $name > 2) {
                $inCore->halt();
            }

            // Если нет названия рубрики
            if (!$title || !$content || $male == 2 || $name == 2 || $category == 0) {

                // Сохраняем текст ошибки в сессию
                cmsCore::addSessionMessage('Нужно заполнить все поля!', 'error');

                // Делаем редирект обратно на форму
                $inCore->redirectBack();
                exit;
            }

            // Записываем значение и получаем флаг успеха
            $is_save = $model->newItem($category, $title, $content, $male, $name);

            if ($is_save) {
                // Сохраняем текст успеха
                cmsCore::addSessionMessage('Новое значение сохранено! Вы можете <a href="/vnaps/add.html">добавить</a> еще одно значение.', 'success');
            }

            if (!$is_save) {
                // Сохраняем текст неудачи
                cmsCore::addSessionMessage('Произошла ошибка при сохранении значения!', 'error');
            }

            // Делаем редирект на созданную запись
            $inCore->redirect('/vnaps/' . $male . $name . $category . '/' . $is_save);
            exit;
        }
    }
// ========================================================================== //
    if ($do == 'view_category') {

        $male = $inCore->request('male', 'int');
        $name = $inCore->request('name', 'int');
        $category = $inCore->request('category', 'int');

        if ($male > 1 or $name > 1) {
            cmsCore::error404();
        }

        if (!$category_array = $model->getCategory($male, $name, $category)) {
            cmsCore::error404();
        }

        $male_txt = $male ? 'мужские' : 'женские';
        $name_txt = $name ? 'имена' : 'отчества';

        $allName = $category_array[0]['name'] . ' ' . $male_txt . ' ' . $name_txt;
        $allNameUri = $male . $name . $category;

        $items = $model->getItemNameList($male, $name, $category);

        $inPage->setTitle($allName);
        $inPage->addPathway($allName, '/' . $_LANG['URI'] . '/' . $allNameUri);
        $smarty = $inCore->initSmarty('components', 'com_vnaps_category.tpl');
        $smarty->assign('title', $allName);
        $smarty->assign('uri', $allNameUri);
        $smarty->assign('names', $items);
        $smarty->assign('user_id', $inUser->id);
        $smarty->display('com_vnaps_category.tpl');
    }
// ========================================================================== //
    if ($do == 'view_item') {

        $male = $inCore->request('male', 'int');
        $name = $inCore->request('name', 'int');
        $category = $inCore->request('category', 'int');
        $item = $inCore->request('item', 'int');

        if ($male > 1 or $name > 1) {
            cmsCore::error404();
        }

        if (!$category_name = $model->getCategory($male, $name, $category)) {
            cmsCore::error404();
        }

        if (!$item_array = $model->getItem($male, $name, $category, $item)) {
            cmsCore::error404();
        }

        $male_txt = $male ? 'мужские' : 'женские';
        $name_txt = $name ? 'имена' : 'отчества';

        $allName = $category_name[0]['name'] . ' ' . $male_txt . ' ' . $name_txt;
        $allNameUri = $male . $name . $category;

        $items = $model->getItemNameList($male, $name, $category);

        $inPage->setTitle($item_array['title']);
        $inPage->addPathway($allName, '/' . $_LANG['URI'] . '/' . $allNameUri);
        $inPage->addPathway($item, '/' . $_LANG['URI'] . '/' . $allNameUri);
        $inPage->addPathway($item_array['title'], '/' . $_LANG['URI'] . '/' . $allNameUri . '/' . $item_array['id']);
        $smarty = $inCore->initSmarty('components', 'com_vnaps_item.tpl');
        $smarty->assign('item_id', $item_array['id']);
        $smarty->assign('item_title', $item_array['title']);
        $smarty->assign('item_content', $inCore->parseSmiles($item_array['content'], true));

        $is_author = ($inUser->id && ($item_array['author'] == $inUser->id));
        $smarty->assign('is_author', $is_author);
        $smarty->assign('is_admin', $inUser->is_admin);
        $smarty->assign('user_id', $inUser->id);

        $smarty->display('com_vnaps_item.tpl');

        // если включены комментарии, то показываем их
        if ($inCore->isComponentInstalled('comments')) {
            cmsCore::includeComments();
            comments('vnaps', $item_array['id']);
        }
    }
// ========================================================================== //
}