<?php

// ========================================================================== //
//                                                                            //
//                        Значения имен и отчеств, v1.0                       //
//                                                                            //
//                      Copyright (C) 2012 Preventiva LLC                     //
//                         http://web2.0-developer.ru/                        //
//                                                                            //
// ========================================================================== //

if (!defined('VALID_CMS')) {
    die('ACCESS DENIED');
}

class cms_model_vnaps {

    function __construct() {

        $this->inCore = cmsCore::getInstance();
        $this->inDB = cmsDatabase::getInstance();
        $this->inUser = cmsUser::getInstance();
    }
    
// ========================================================================== //
    // Возвращает категории мужских имен
    public function getMaleNamesCategory() {

        return $this->getCategory(1, 1);
    }

    // Возвращает категории женских имен
    public function getFemaleNamesCategory() {

        return $this->getCategory(0, 1);
    }

    // Возвращает категории мужских отчеств
    public function getMalePatronymicsCategory() {

        return $this->getCategory(1, 0);
    }

    // Возвращает категории женских отчеств
    public function getFemalePatronymicsCategory() {

        return $this->getCategory(0, 0);
    }

    // Возвращает значения категорий
    public function getCategory($male, $name, $category = '') {

        if ($category != '') {
            $category = "`c`.`id` = '$category' AND ";
        }

        $sql = "SELECT `c`.`id`, `c`.`name`, count( `i`.`category` ) AS `cnt`
            FROM `cms_vnaps_items` `i`, `cms_vnaps_category` `c`
            WHERE $category `i`.`category` = `c`.`id`
            AND `i`.`male` = '$male'
            AND `i`.`name` = '$name'
            GROUP BY `i`.`category`
            ORDER BY `c`.`name` ASC";

        $result = $this->inDB->query($sql);

        //если возникла ошибка
        if ($this->inDB->error()) {
            return false;
        }

        //если подкатегорий нет
        if (!$this->inDB->num_rows($result)) {
            return false;
        }

        $out_list = false;

        while ($row = $this->inDB->fetch_assoc($result)) {
            $out_list[] = $row;
        }

        return $out_list;
    }

    // Возвращает названия категорий
    public function getCategoryName() {

        $sql = "SELECT `c`.`id`, `c`.`name`
            FROM `cms_vnaps_category` `c`
            ORDER BY `c`.`name` ASC";

        $result = $this->inDB->query($sql);

        //если возникла ошибка
        if ($this->inDB->error()) {
            return false;
        }

        //если подкатегорий нет
        if (!$this->inDB->num_rows($result)) {
            return false;
        }

        $out_list = false;

        while ($row = $this->inDB->fetch_assoc($result)) {
            $out_list[] = $row;
        }

        return $out_list;
    }

    // Возвращает названия имен (отчеств) в категории
    public function getItemNameList($male, $name, $category) {

        $sql = "SELECT `i`.`id`, `i`.`title`
            FROM `cms_vnaps_items` `i`
            WHERE `i`.`category` = '$category'
            AND `i`.`male` = '$male'
            AND `i`.`name` = '$name'
            ORDER BY `i`.`title` ASC";

        $result = $this->inDB->query($sql);

        //если возникла ошибка
        if ($this->inDB->error()) {
            return false;
        }

        //если имен нет
        if (!$this->inDB->num_rows($result)) {
            return false;
        }

        $out_list = false;

        while ($row = $this->inDB->fetch_assoc($result)) {
            $out_list[] = $row;
        }

        // Делаем только если в массиве что то есть
        if ($out_list) {

            // Заполняем массив первыми буквами имен
            foreach ($out_list as $value) {

                $first = mb_strtoupper(mb_substr($value['title'], 0, 1));

                // Содержит первые буквы всех имен без повтора
                $oneLit[$first] = $first;
            }

            // Заполняем массив именами с ключом по первой букве имен
            foreach ($oneLit as $key) {

                // Пробегаемся по массиву с именами
                foreach ($out_list as $value) {

                    // Если первые буквы совподают...
                    $first = mb_strtoupper(mb_substr($value['title'], 0, 1));
                    if ($first == $key) {
                        $out_array[$key][] = array('id' => $value['id'], 'title' => $value['title']);
                    }
                }
            }
        }

        // Содержит многомерный массив с именами
        // сгруппированный по первой букве имени
        return $out_array;
    }

    // Возвращает название имени (отчества) и его подробное описание
    public function getItem($male, $name, $category, $item) {

        $sql = "SELECT `i`.`id`, `i`.`author`, `i`.`title`, `i`.`content`
            FROM `cms_vnaps_items` `i`
            WHERE `i`.`category` = '$category'
            AND `i`.`male` = '$male'
            AND `i`.`name` = '$name'
            AND `i`.`id` = '$item'";

        $result = $this->inDB->query($sql);

        //если возникла ошибка
        if ($this->inDB->error()) {
            return false;
        }

        //если имени нет
        if (!$this->inDB->num_rows($result)) {
            return false;
        }

        return $this->inDB->fetch_assoc($result);
    }

    // Возвращает из БД по ID всю строку с записью об имени (отчестве)
    public function getItemTitle($item) {

        $sql = "SELECT `i`.*
            FROM `cms_vnaps_items` `i`
            WHERE `i`.`id` = '$item'
            LIMIT 1";

        $result = $this->inDB->query($sql);

        //если возникла ошибка
        if ($this->inDB->error()) {
            return false;
        }

        //если имени нет
        if (!$this->inDB->num_rows($result)) {
            return false;
        }

        return $this->inDB->fetch_assoc($result);
    }

    // Возвращает массив с содержанием title ⇒ заголовок, link ⇒ ссылка на основной материал
    public function getCommentTarget($target, $target_id) {

        $result = array();

        switch ($target) {

            case 'vnaps': $item = $this->getItemTitle($target_id);
                if (!$item) {
                    return false;
                }
                $result['link'] = '/vnaps/' . $item['male'] . $item['name'] . $item['category'] . '/' . $target_id;
                $title = $item['male'] ? 'Значение мужского ' : 'Значение женского ';
                $title .= $item['name'] ? 'имени "' : 'отчества "';
                $male_txt = $male ? 'мужские' : 'женские';
                $result['title'] = $title . $item['title'] . '"';
                break;
        }

        return ($result ? $result : false);
    }

    // Создает новое значение и возвращает его номер
    public function newItem($category, $title, $content, $male, $name) {

        $author = $this->inUser->id;

        $title = $this->mb_ucfirst(mb_strtolower($title));

        $content = $this->mb_ucfirst($content);

        $sql = "INSERT INTO `cms_vnaps_items` (`id`, `category`, `author`, `title`, `content`, `male`, `name`)
        VALUES (NULL, '$category', '$author', '$title', '$content', '$male', '$name');";

        $this->inDB->query($sql);

        // Если возникла ошибка, вернем false
        if ($this->inDB->error()) {
            return false;
        }

        $item_id = $this->inDB->get_last_id('cms_vnaps_items');

        //регистрируем событие
        cmsActions::log('vnaps_add', array(
            'object' => $title,
            'object_url' => '/vnaps/' . $male . $name . $category . '/' . $item_id,
            'object_id' => $item_id,
            'target' => '',
            'target_url' => '',
            'target_id' => '',
            'description' => $this->inCore->parseSmiles($content, true)
        ));

        // Елси ошибок не было, вернем ID новой записи
        return $item_id;
    }

    // Редактирует значение
    public function editItem($item_id, $category, $title, $content, $male, $name) {

        $title = $this->mb_ucfirst(mb_strtolower($title));

        $content = $this->mb_ucfirst($content);

        $sql = "UPDATE `cms_vnaps_items`
        SET `category` = '$category', `title` = '$title', `content` = '$content', `male` = '$male', `name` = '$name'
        WHERE `id` = '$item_id' LIMIT 1;";

        $this->inDB->query($sql);

        // Если возникла ошибка, вернем false
        if ($this->inDB->error()) {
            return false;
        }

        //регистрируем событие
        cmsActions::log('vnaps_edit', array(
            'object' => $title,
            'object_url' => '/vnaps/' . $male . $name . $category . '/' . $item_id,
            'object_id' => $item_id,
            'target' => '',
            'target_url' => '',
            'target_id' => '',
            'description' => $this->inCore->parseSmiles($content, true)
        ));

        // Если ошибок не было
        return true;
    }

    // Удаляет значение по ID
    public function deleteItem($item_id) {

        $sql = "DELETE FROM `cms_vnaps_items` WHERE `id` = '$item_id' LIMIT 1;";

        $this->inDB->query($sql);

        // Если возникла ошибка, вернем false
        if ($this->inDB->error()) {
            return false;
        }

        $this->inCore->deleteComments('vnaps', $item_id);

        // Если ошибок не было
        return true;
    }

    // Возвращает текст но уже с заглавной буквы
    public function mb_ucfirst($word, $chr = "utf-8") {

        return mb_strtoupper(mb_substr($word, 0, 1, $chr), $chr) .
                mb_substr($word, 1, mb_strlen($word, $chr) - 1, $chr);
    }

// ========================================================================== //
}

